#include <vector>
#include <iostream>
#include <string>
#include <fstream>
#include "Semester.h"
#include "UClass.h"
#include "Biob.h"
#include "Egen.h"
#include "Csci.h"

void Semester::Read(std::ifstream &ifs)
{
    UClass c;
    std::string line;
    while (getline(ifs, line))
    {
        c.setFromCsvLine(line);

        if (c.getType() == "CSCI")
        {
            // This casts the pointer to class
            // Doesn't require a special cast method
            // in our case because nothing changes
            //
            /* Csci *tmp = (Csci *)&c; */
            /* cvec.push_back(*tmp); */

            //This uses our defined cast method
            cvec.push_back((Csci)c);
            // p1->Print();
        }
        else if (c.getType() == "EGEN")
        {
            /* Egen *tmp = (Egen *)&c; */
            /* evec.push_back(*tmp); */
            evec.push_back((Egen)c);
            // evec.push_back((Egen::Egen &)c);
        }
        else if (c.getType() == "BIOB")
        {
            /* Biob *tmp = (Biob *)&c; */
            /* bvec.push_back(*tmp); */
            bvec.push_back((Biob)c);
            // bvec.push_back((Biob::Biob &)c);
        }
    }
}

void Semester::PrintType(std::string type)
// This function is very similar to print num, except it prints all classes in category
{
    if (!type.compare("BIOB"))
    {
        for (Biob b : bvec)
        {
            b.Print();
        }
    }
    else if (!type.compare("CSCI"))
    {
        for (Csci c : cvec)
        {
            c.Print();
        }
    }
    else if (!type.compare("EGEN"))
    {
        for (Egen e : evec)
        {
            e.Print();
        }
    }
    else
    {
        std::cout << "Input doesn't match BIOB, CSCI, or EGEN (Make sure it's upper case)" << std::endl;
    }
}

void Semester::PrintNumber(std::string type, std::string number)
// Lots of comparisons
{
    if (!type.compare("BIOB"))
    {
        for (Biob b : bvec)
        {
            if (!b.getNum().compare(number))
            {
                b.Print();
            }
        }
    }
    else if (!type.compare("CSCI"))
    {
        for (Csci c : cvec)
        {
            if (!c.getNum().compare(number))
            {
                c.Print();
            }
        }
    }
    else if (!type.compare("EGEN"))
    {
        for (Egen e : evec)
        {
            if (!e.getNum().compare(number))
            {
                e.Print();
            }
        }
    }
    else
    {
        std::cout << "Input doesn't match BIOB, CSCI, or EGEN (Make sure it's upper case)" << std::endl;
        std::cout << "Or, the number is not in the database" << std::endl;
    }
}
