#include <iostream>
#include <fstream>
#include <stdexcept>
#include <string>
#include "Semester.h"

void GivenType(Semester sem)
{
    // prints, gets input, sends it to semester
    std::cout << "Enter type (CSCI, EGEN, or BIOB): ";
    std::string type;
    std::cin >> type;
    sem.PrintType(type);
}

void GivenNumber(Semester sem)
{
    // prints, gets input, sends it to semester
    std::cout << "Enter class type and class number (ex: CSCI 112): ";
    std::string type, number;
    std::cin >> type;
    std::cin >> number;
    sem.PrintNumber(type, number);
}

bool Menuing(Semester sem)
{
    std::cout << "Choices:" << std::endl;
    std::cout << "n - print class given number" << std::endl;
    std::cout << "t - print all classes for a given type" << std::endl;
    std::cout << "q - quit" << std::endl;

    std::string input;
    std::cin >> input;

    if (!input.compare("n"))
    {
        GivenNumber(sem);
    }
    else if (!input.compare("t"))
    {
        GivenType(sem);
    }
    else if (!input.compare("q"))
    {
        return false;
    }
    return true; // runs menu again if input is bad or we're not done yet
}

int main(int argc, char *argv[])
{
    std::ifstream ifs;

    // Lets us not use a command line arg for fun
    if (argc == 1)
    {
        std::cout << "Okay, I suppose you don't need a command line arg" << std::endl;
        ifs.open("/public/pgm3/classes.csv");
    }
    else if (argc != 2) // But not more than one!
    {
        throw std::invalid_argument("Need one commandline arg, which is filepath");
    }
    else // For the command line arg
    {
        ifs.open(argv[1]);
    }

    Semester sem;
    sem.Read(ifs); // reads in the file and vectorizes

    while (Menuing(sem) == true) // keeps menuing till we exit
    {
    }

    return (0);
}
